.TH PRIVATE_PROP 1 "Oct 29 1994" "Stanford University" "SUIF Compiler"
.SH NAME
private_prop \- propagate privatization information interprocedurally
.SH SYNOPSIS
.B private_prop -pre-pass
.I infile
.I outfile
{
.I infile
.I outfile
}*
.sp
.B rescope
.I infile
.I outfile
{
.I infile
.I outfile
}*
.sp
.B private_prop
.I infile
.I outfile
{
.I infile
.I outfile
}*
.SH DESCRIPTION
The
.I private_prop
program propagates information about which globals are privatized onto
all the procedures in which the private copies might be used.  It
reads the ``privatized'' and ``reduced'' annotes on tree_for nodes to
find privatized globals and writes out its results as lists of symbols
in ``possible global privatizable'' annotations on the proc_syms.
.sp
This pass assumes that if a callsite has either of the annotations
``call mod syms'' or ``call ref syms'', then there is at most one of
each of these annotations at the callsite and that if a global
variable is read or written by the callee or anything it calls at any
level, that variable is listed in at least one of these two
annotations.  If a callsite has neither of these annotations, this
pass assumes that any global might be read or written on the other
side of the callsite.
.sp
This pass also assumes that if there are any indirect calls (calls
through pointers) or calls to external procedures (any procedures that
are not defined in the files given to this pass), no privatized
globals are used on the other side of the call.  It's up to the pass
that finds parallelization and marks privatizable variables to insure
this is the case.
.sp
Since this pass sometimes needs to move variables from file scope to
inter-file scope, it needs to use the
.B rescope
pass.  So this pass needs to be run with the ``-pre-pass'' option,
then
.B rescope
can be run, then this pass can be run again to do the actual work.
.SH SEE ALSO
rescope(1)
pgen(1)
.SH HISTORY
This program was written by Chris Wilson.
